#include <3ds.h>
#include <stdio.h>

enum
{
	WIFI_DISCONNECTED = 0,
	WIFI_DISABLED = 0xe0a09d2e
};

Result getWifiStatus()
{
	Result r = acInit();
	if (R_FAILED(r))
		return r;

	u32 wifiStatus = 0;
	r = ACU_GetWifiStatus(&wifiStatus);

	acExit();

	if (R_FAILED(r))
		return r;

	return wifiStatus;
}

// TODO: Once the actual command to query if wifi is powered on or not 
// is discovered, use that instead.
void toggleWifi()
{
	Result wifiStatus = getWifiStatus();
	if (R_SUCCEEDED(nwmExtInit()))
	{
		if (wifiStatus == WIFI_DISCONNECTED || wifiStatus == WIFI_DISABLED)
			NWMEXT_ControlWirelessEnabled(NWMEXT_WIFI_ENABLE);
		else
			NWMEXT_ControlWirelessEnabled(NWMEXT_WIFI_DISABLE);
	}
	nwmExtExit();
}

int main(int argc, char **argv)
{
	toggleWifi();

	while (aptMainLoop())
		break;

	return 0;
}
